Crypto++ 8.2 Free C++ class library of cryptographic schemes

Classes | Public Member Functions | List of all members
EqualityComparisonFilter Class Reference

A filter that checks messages on two channels for equality. More...

Inheritance diagram for EqualityComparisonFilter:

## Classes
struct | MismatchDetected

## Public Member Functions
| EqualityComparisonFilter (BufferedTransformation *attachment=NULL, bool throwIfNotEqual=true, const std::string &firstChannel="0", const std::string &secondChannel="1")
size_t | ChannelPut2 (const std::string &channel, const byte *begin, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel. More...
bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Marks the end of a series of messages on a channel. More...
Public Member Functions inherited from Unflushable< Multichannel< Filter > >
bool | Flush (bool completeFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation. More...
bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
Public Member Functions inherited from Multichannel< Filter >
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing. More...
size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
bool | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutModifiable2 (const std::string &channel, byte *begin, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
SIGNALS
Public Member Functions inherited from Filter
| Filter (BufferedTransformation *attachment=NULL)
| Construct a Filter. More...
bool | Attachable ()
| Determine if attachable. More...
BufferedTransformation * | AttachedTransformation ()
| Retrieve attached transformation. More...
const BufferedTransformation * | AttachedTransformation () const
| Retrieve attached transformation. More...
void | Detach (BufferedTransformation *newAttachment=NULL)
| Replace an attached transformation. More...
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation. More...
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation. More...
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation. More...
virtual void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals. More...
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation. More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual bool | GetNextMessage ()
| Start retrieving the next message. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Detailed Description

A filter that checks messages on two channels for equality.

Definition at line 71 of file mqueue.h.

## Constructor & Destructor Documentation

## ◆ EqualityComparisonFilter()

EqualityComparisonFilter::EqualityComparisonFilter | ( | BufferedTransformation * | attachment = `NULL`,
|  | bool | throwIfNotEqual = `true`,
|  | const std::string & | firstChannel = `"0"`,
|  | const std::string & | secondChannel = `"1"`
| ) |  |
| inline

if throwIfNotEqual is false, this filter will output a '\0' byte when it detects a mismatch, '\1' otherwise

Definition at line 77 of file mqueue.h.

## Member Function Documentation

## ◆ ChannelPut2()

size_t EqualityComparisonFilter::ChannelPut2 | ( | const std::string & | channel,
|  | const byte * | begin,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking
| ) |  |
| virtual

Input multiple bytes for processing on a channel.

Parameters

  channel | the channel to process the data.
  begin | the byte buffer to process.
  length | the size of the string, in bytes.
  messageEnd | means how many filters to signal MessageEnd() to, including this one.
  blocking | specifies whether the object should block when processing input.

Returns
  the number of bytes that remain to be processed (i.e., bytes not processed)

Implements Multichannel< Filter >.

Definition at line 84 of file mqueue.cpp.

## ◆ ChannelMessageSeriesEnd()

bool EqualityComparisonFilter::ChannelMessageSeriesEnd | ( | const std::string & | channel,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) |  |
| virtual

Marks the end of a series of messages on a channel.

Parameters

  channel | the channel to signal the end of a series of messages
  propagation | the number of attached transformations the ChannelMessageSeriesEnd() signal should be passed
  blocking | specifies whether the object should block when processing input

Returns
  true if the message was successful, false otherwise

Each object that receives the signal will perform its processing, decrement propagation, and then pass the signal on to attached transformations if the value is not 0.

propagation count includes this object. Setting propagation to `1` means this object only. Setting propagation to `-1` means unlimited propagation.

Note
  There should be a MessageEnd() immediately before MessageSeriesEnd().

Reimplemented from BufferedTransformation.

Definition at line 135 of file mqueue.cpp.

The documentation for this class was generated from the following files:

- mqueue.h
- mqueue.cpp